
(defun c:popTin (/ ssTin ssObj idx obj insPt)
  
  ;select a tin surface
  (setq ssTin (car (entsel "Select a TIN surface : /n")))
  (prompt "Select the objects to populate the TIN surface : /n")
  (setq ssObj (ssget)
        idx 0)
  
  (while (< idx (sslength ssObj))
    (vl-cmdf "_MOVE" (setq obj (ssname ssObj idx)) ""
             (setq insPt (cdr (assoc 10 (entget obj))))  ;from point 
             
             ; get the elevation of the insertion point on the TIN surface
             (list (car insPt)(cadr insPt)(tin:elevationatpointV20 ssTin insPt nil nil)) ;to TIN Elevation
             
             ; alternatively find the elevation using an intersection of a virtual line
             ; connecting the object insertion point and the point having the max tin elevation ...
             
             ;(tin:getintersectionswithline  ssTin  insPt  (list (car insPt)(cadr insPt)(tin:getmaxelevation ssTin NIL))  NIL  NIL) ;to TIN Elevation
             
    )
    ; get next object
    (setq idx (1+ idx))
  );w
  
)

;;; call (tin:elevationatpointV20 (car(entsel)) (getpoint) nil nil) 

(defun tin:elevationatpointV20 (tinSurf point3d flag1 flag2 / bounds pl dpl vlin elevAtP)
  
  ; get the lower-left and top-right points of the TIN surface
  (setq bounds (vbbox tinsurf))
  ; draw a horizontal polyline in XY direction throught the point3D bounded by bounds
  (vl-cmdf "._PLINE" (list (nth 0 point3d )(nth 1 (nth 0 bounds)) (nth 2 point3d ))
                     (list (nth 0 point3d )(nth 1 (nth 1 bounds)) (nth 2 point3d ))
                     ""
  )
  (setq pl (entlast))
  ;drape the polyline on the TIN surface
  (vl-cmdf "_TINDRAPEPOLY" tinSurf pl)  
  (setq dpl (entlast))
  ;draw a vertical line through point3d bounded by bounds
  (vl-cmdf "._LINE"  (list (nth 0 point3d )(nth 1 point3d )(nth 2 (nth 0 bounds)))
                     (list (nth 0 point3d )(nth 1 point3d )(nth 2 (nth 1 bounds)))
                     ""
  )
  (setq vlin (entlast))
  ; return the intersection point of the vertical line with the draped 3d polyline...
  (setq elevAtP (vlax-safearray->list (vlax-variant-value 
                (vla-IntersectWith (vlax-ename->vla-object vlin) (vlax-ename->vla-object dpl) acExtendThisEntity)))
  )
  (if (= flag1 nil)
    (progn
      (entdel dpl)
     )
  )
  (if (= flag2 nil)
    (progn
      (entdel pl)
      (entdel vlin)
    )
  )
  (nth 2 elevAtP)
)





;;;;;;returns bounding box as 2 points
(defun vbbox ( objid / minb maxb)
  
 (if (= (type objid) 'ENAME) ; if ENAME is passed convert to VLAobject
    (setq objid (vlax-ename->vla-object objid)) 
    )
	(vla-GetBoundingBox objid 'minb 'maxb)
	(setq minb (vlax-safearray->list minb)
	      maxb (vlax-safearray->list maxb)
        )
	(list minb maxb)
)

